from django.db import models
from commandes.models import Commande
from clients.models import Client
from lots.models import Lot
from articles.models import Article
from django.core.validators import MinValueValidator
from decimal import Decimal



# Create your models here.
class ArticleCommandee(models.Model):
	commande = models.ForeignKey(Commande, on_delete=models.CASCADE, null=True, blank=True)
	article = models.ForeignKey(Article, on_delete=models.SET_NULL, null=True, blank=True)
	lot = models.ForeignKey(Lot, on_delete=models.SET_NULL, null=True, blank=True)
	qantite_total = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True,default=0)
	qantite_reste = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True,default=0)
	emballee = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True ,default=0)
	expediee = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True,default=0)
	qantite_recu  = models.DecimalField(decimal_places=0, max_digits=19, blank=True, default=0, validators=[MinValueValidator(Decimal('0.00'))])
	quantitee_recu  = models.DecimalField(decimal_places=0, max_digits=19, blank=True, default=0, validators=[MinValueValidator(Decimal('0.00'))])
	renvoyee = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True,default=0)
	taxe =  models.DecimalField(max_digits=10, decimal_places=2 , blank=True , null=True,default=0)
	montant =  models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True,default=0.0)
	montant_reste = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True,default=0.0)
	description = models.CharField(max_length= 250 , blank=True , null=True)
	remise =   models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True,default=0.0)
	created_at = models.DateTimeField(auto_now_add=True)
	updated_at = models.DateTimeField(auto_now=True)
	taux =  models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True,default=0)
	reste_emballee = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True ,default=0)
	quantitee_renvoyee = models.DecimalField(decimal_places=0, max_digits=19, blank=True, default=0, validators=[MinValueValidator(Decimal('0.00'))])
