# -*- encoding: utf-8 -*-
"""
Copyright (c) 2019 - present AppSeed.us
"""

from django.shortcuts import render

# Create your views here.
from django.shortcuts import render, redirect
from django.contrib.auth import authenticate, login
from django.contrib.auth.models import User
from django.forms.utils import ErrorList
from django.http import HttpResponse
from .forms import LoginForm, SignUpForm
from django.contrib.auth.models import Group 
from core.decorators import allowed_users

def login_view(request):
    form = LoginForm(request.POST or None)

    msg = None

    if request.method == "POST":

        if form.is_valid():
            username = form.cleaned_data.get("username")
            password = form.cleaned_data.get("password")
            user = authenticate(username=username, password=password)
            if user is not None:
                login(request, user)
                return redirect("/customers/profile/")
            else:
                msg = 'Identifiants non valides'
        else:
            msg = 'Erreur de validation du formulaire'

    return render(request, "accounts/login.html", {"form": form, "msg": msg})

@allowed_users(allowed_roles=['admingestion'])
def register_user(request):
    msg = None
    success = False

    if request.method == "POST":
        form = SignUpForm(request.POST)
        if form.is_valid():
            form.save()
            username = form.cleaned_data.get("username")
            raw_password = form.cleaned_data.get("password1")
            g = request.POST.get("group")
            user = authenticate(username=username, password=raw_password)

            userid = User.objects.last().id
            us = User.objects.get(id = userid)
            print('group' ,g)
            group = Group.objects.get(name=g)
            group.user_set.add(us) 
            msg = 'User created - please <a href="/login">login</a>.'
            success = True

            # return redirect("/login/")

        else:
            msg = 'Form is not valid'
    else:
        form = SignUpForm()

    return render(request, "accounts/register.html", {"form": form, "msg": msg, "success": success ,"group" :Group.objects.all() ,'segment' :'register' })
