from django.shortcuts import render ,redirect
from django.contrib import messages
from commandes.models import Commande
from django.contrib.auth.decorators import login_required
from articlescommandee.models import ArticleCommandee
from avisderecu.forms import  AvisderecuForm ,form_validation_error
from avisderecu.models import Avisderecu
from detailsavisderecu.models import Detailsavisderecu
from django import template
from articles.models import Article
import decimal
# Create your views here.

register = template.Library()

@login_required(login_url="/login/")
def affiche_ajouter_avis_recu(request):
	context = {}
	if request.method == "POST":
		id_commande = request.POST.get('id_commande')
		commande = Commande.objects.get(id = id_commande)
		articlecommandee = ArticleCommandee.objects.filter(commande=commande).order_by('created_at')
		context['articlecommandee'] = articlecommandee
		context['commande'] = commande
		numc = Avisderecu.objects.all().exclude(num_avisrecu = 0).order_by('created_at').reverse().first()
		if numc  :
			context['num_avis'] = '00'+ str(int(numc.num_avisrecu) + 1)
		else :
			context['num_avis']  = '001'

	return render(request, 'ajouter-avis-recu.html', context)

@login_required(login_url="/login/")
def ajouter_aviderecu(request):
	context = {}
	if request.method == "POST":
		articleCommande = request.POST.getlist('article_options[]')
		qantite_recu = request.POST.getlist('qantite_recu[]')
		form = AvisderecuForm(request.POST or None)
		if form.is_valid():
			print("is valid")
			form.save()
			last_avisderecu = Avisderecu.objects.last().id
			avisderecu = Avisderecu.objects.get(id = last_avisderecu)
			qantite_total_emballee =0

			for i in range(len(qantite_recu)):
				if decimal.Decimal(qantite_recu[i]) > 0 :
					articlecommande = ArticleCommandee.objects.get( id = articleCommande[i])
					rest_recu = articlecommande.qantite_total - articlecommande.qantite_recu

					if rest_recu >= decimal.Decimal(qantite_recu[i]):
							detailsavisderecu = Detailsavisderecu(avisderecu = avisderecu , articlecommandee = articlecommande,qantite=decimal.Decimal(qantite_recu[i]))
							detailsavisderecu.save()

							qt_recu = articlecommande.qantite_recu + decimal.Decimal(qantite_recu[i])
							ArticleCommandee.objects.filter(id = articlecommande.id).update(qantite_recu = qt_recu)
							article = Article.objects.get(id = articlecommande.article.id)
							new_s_p_d = article.stock_physique_disponible + decimal.Decimal(qantite_recu[i])
							new_s_p_d_v = article.stock_physique_disponible_a_la_vente + decimal.Decimal(qantite_recu[i])

							Article.objects.filter(id = articlecommande.article.id).update(stock_physique_disponible = new_s_p_d)
							Article.objects.filter(id = articlecommande.article.id).update(stock_physique_disponible_a_la_vente = new_s_p_d_v)
					
				
			id_commande = request.POST.get('commande')
			commande = Commande.objects.get(id = id_commande)
			final_list_articla_commande = ArticleCommandee.objects.filter(commande=commande)
			rest_recu_total = 0
			qantite_total =0
			for arf in final_list_articla_commande :
				rest_recu_total = rest_recu_total + (arf.qantite_total-arf.qantite_recu)
				qantite_total = qantite_total + arf.qantite_total

			if rest_recu_total == qantite_total  :
				Commande.objects.filter(id = commande.id).update(reçu = 'Non reçu')
				if Commande.objects.get(id = commande.id).facturee == 'facturee':
					Commande.objects.filter(id = commande.id).update(status = 'Emise')		
			elif rest_recu_total == 0:
				Commande.objects.filter(id = commande.id).update(reçu = 'Reçu')
				if Commande.objects.get(id = commande.id).facturee == 'facturee':
					Commande.objects.filter(id = commande.id).update(status = 'Fermer')		
			else :
				Commande.objects.filter(id = commande.id).update(reçu = 'Partiellement reçu')

			messages.success(request, 'avis de réception a été bien ajouté')	
		else :
			messages.error(request, 'avis de réception n est pas ajoute')	
	return redirect('liste_bon_commandes')


@login_required(login_url="/login/")
def affiche_avis_reception(request):
	context = {}
	if request.method == "POST":
		id_recu = request.POST.get('avisrecu')
		avisderecu = Avisderecu.objects.get(id = id_recu)
		detailsavisderecu = Detailsavisderecu.objects.filter(avisderecu=avisderecu).order_by('created_at') 
		context['detailsavisderecu'] = detailsavisderecu
		context['avis'] = avisderecu

	return render(request, 'afficher-avis-de-reception.html', context)	



@login_required(login_url="/login/")
def modifier_avis_reception(request):
	context = {}
	if request.method == "POST":
		id_recu = request.POST.get('avisrecu')
		avisderecu = Avisderecu.objects.get(id = id_recu)

		detailsavisderecu = Detailsavisderecu.objects.filter(avisderecu=avisderecu).order_by('created_at') 
		context['articlecommandeerecu'] = detailsavisderecu
		context['avisrecu'] = avisderecu

	return render(request, 'modifier-avis-recu.html', context)	



@login_required(login_url="/login/")
def valider_modifier_aviderecu(request):
	context = {}
	if request.method == "POST":
		articleCommanderecu = request.POST.getlist('article_options[]')
		qantite_recu = request.POST.getlist('qantite_recu[]')
		
		num_avisrecu = request.POST.get('num_avisrecu')
		date = request.POST.get('date')
		note = request.POST.get('note')

		id_avirecu = request.POST.get('avisrecu')
	
		avisderecu = Avisderecu.objects.get(id = id_avirecu)
		Avisderecu.objects.filter(id = id_avirecu).update(num_avisrecu = num_avisrecu)
		Avisderecu.objects.filter(id = id_avirecu).update(date = date)
		Avisderecu.objects.filter(id = id_avirecu).update(note = note)


		for i in range(len(qantite_recu)):
				detailsavirec = Detailsavisderecu.objects.get(id = articleCommanderecu[i])
				articlecommande = ArticleCommandee.objects.get( id = detailsavirec.articlecommandee.id)
				article = Article.objects.get(id = articlecommande.article.id)

				if decimal.Decimal(qantite_recu[i]) > 0 :
					if decimal.Decimal(qantite_recu[i]) > detailsavirec.qantite :
						dif_qte = decimal.Decimal(qantite_recu[i]) - detailsavirec.qantite
						new_qantite_recu = articlecommande.qantite_recu + dif_qte

						new_s_p_d = article.stock_physique_disponible + dif_qte
						new_s_p_d_v = article.stock_physique_disponible_a_la_vente + dif_qte

					else : 
						dif_qte =  detailsavirec.qantite - decimal.Decimal(qantite_recu[i])
						new_qantite_recu = articlecommande.qantite_recu - dif_qte
						new_s_p_d = article.stock_physique_disponible - dif_qte
						new_s_p_d_v = article.stock_physique_disponible_a_la_vente - dif_qte

					
					ArticleCommandee.objects.filter(id = articlecommande.id).update(qantite_recu = new_qantite_recu)
					Article.objects.filter(id = articlecommande.article.id).update(stock_physique_disponible = new_s_p_d)
					Article.objects.filter(id = articlecommande.article.id).update(stock_physique_disponible_a_la_vente = new_s_p_d_v)
					
					Detailsavisderecu.objects.filter(id = articleCommanderecu[i]).update(qantite = qantite_recu[i])
				else :	
					new_qantite_recu = articlecommande.qantite_recu - detailsavirec.qantite
					new_s_p_d = article.stock_physique_disponible - detailsavirec.qantite
					new_s_p_d_v = article.stock_physique_disponible_a_la_vente - detailsavirec.qantite
					
						
					ArticleCommandee.objects.filter(id = articleCommanderecu[i]).update(qantite_recu = new_qantite_recu)
					Article.objects.filter(id = articlecommande.article.id).update(stock_physique_disponible = new_s_p_d)
					Article.objects.filter(id = articlecommande.article.id).update(stock_physique_disponible_a_la_vente = new_s_p_d_v)
					detailsavirec.delet()

				
		commande = Commande.objects.get(id = avisderecu.commande.id)
		final_list_articla_commande = ArticleCommandee.objects.filter(commande=commande)
		rest_recu_total = 0
		qantite_total =0
		for arf in final_list_articla_commande :
			rest_recu_total = rest_recu_total + (arf.qantite_total-arf.qantite_recu)
			qantite_total = qantite_total + arf.qantite_total
		print( 'qantite_total' ,qantite_total ,' rest_recu_total ' , rest_recu_total)
		if rest_recu_total == qantite_total  :
			Commande.objects.filter(id = commande.id).update(reçu = 'Reçu')
			if Commande.objects.get(id = commande.id).facturee == 'facturee':
				Commande.objects.filter(id = commande.id).update(status = 'Fermer')
		elif rest_recu_total == 0:
			Commande.objects.filter(id = commande.id).update(reçu = 'Non reçu')		
		else :
			Commande.objects.filter(id = commande.id).update(reçu = 'Partiellement reçu')
		messages.success(request, 'avis de réception a été bien modifier')	
	
	return redirect('liste_bon_commandes')



@login_required(login_url="/login/")
def supprimer_aviderecu(request):
	context = {}
	if request.method == "POST":
		
		id_avirecu = request.POST.get('avisrecu')
		avisderecu = Avisderecu.objects.get(id = id_avirecu)
		detailsavirec = Detailsavisderecu.objects.filter(avisderecu = avisderecu)


		for i in range(len(detailsavirec)):
				articlecommande = ArticleCommandee.objects.get( id = detailsavirec[i].articlecommandee.id)
				article = Article.objects.get(id = articlecommande.article.id)

				new_qantite_recu = articlecommande.qantite_recu - detailsavirec[i].qantite
				new_s_p_d = article.stock_physique_disponible - detailsavirec[i].qantite
				new_s_p_d_v = article.stock_physique_disponible_a_la_vente - detailsavirec[i].qantite
							
				ArticleCommandee.objects.filter(id = detailsavirec[i].articlecommandee.id).update(qantite_recu = new_qantite_recu)
				Article.objects.filter(id = articlecommande.article.id).update(stock_physique_disponible = new_s_p_d)
				Article.objects.filter(id = articlecommande.article.id).update(stock_physique_disponible_a_la_vente = new_s_p_d_v)
		
		
				
		commande = Commande.objects.get(id = avisderecu.commande.id)
		final_list_articla_commande = ArticleCommandee.objects.filter(commande=commande)
		rest_recu_total = 0
		qantite_total =0
		for arf in final_list_articla_commande :
			rest_recu_total = rest_recu_total + (arf.qantite_total - arf.qantite_recu)
			qantite_total = qantite_total + arf.qantite_total
		print( 'qantite_total' ,qantite_total ,' rest_recu_total ' , rest_recu_total)
		
		if rest_recu_total == 0  :
			Commande.objects.filter(id = commande.id).update(reçu = 'Reçu')
			if Commande.objects.get(id = commande.id).facturee == 'facturee':
				Commande.objects.filter(id = commande.id).update(status = 'Fermer')
		elif rest_recu_total == qantite_total :
			Commande.objects.filter(id = commande.id).update(reçu = 'Non reçu')		
		else :
			Commande.objects.filter(id = commande.id).update(reçu = 'Partiellement reçu')
		avisderecu.delete()
		messages.success(request, 'avis de réception a été bien supprimer')	
	
	return redirect('liste_bon_commandes')