from django.db import models

# Create your models here.
from clients.models import Client
from commandes.models import Commande
from articlescommandee.models import ArticleCommandee
from livraison.models import Livraison

class Colis(models.Model):
	livraison = models.ForeignKey(Livraison, on_delete=models.SET_NULL, null=True, blank=True)
	commande = models.ForeignKey(Commande, on_delete=models.CASCADE, null=True, blank=True)
	qantite = models.DecimalField(max_digits=10, decimal_places=2 , blank=True , null=True ,default=0)
	num_colis = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True  ,unique = True)
	status = models.CharField(max_length= 50 , blank=True , null=True)
	date = models.DateField(null=True, blank=True)
	date_de_livraison =  models.DateField(null=True, blank=True)
	note = models.CharField(max_length= 100 , blank=True , null=True)
	created_at = models.DateTimeField(auto_now_add=True)
	updated_at = models.DateTimeField(auto_now=True)