# -*- encoding: utf-8 -*-
"""
Copyright (c) 2019 - present AppSeed.us
"""
from django.conf import settings
from django.contrib import admin
from django.conf.urls.static import static
from django.urls import path, include   # add this

from clients.views import liste_clients , ajouter_client ,affiche_ajouter_client ,afficher_client,affiche_modifier_client ,valider_modifier_client ,supprimer_client
from organisation.views import afficher_organisation , ajouter_organisation
from lots.views import valider_lot, liste_d_entree,liste_des_lots, liste_lots, lots_par, liste_lots_d_article, ajouter_lots ,afficher_modifier_lot ,valider_modifier_lot ,Supprimer_lot ,detail_lot
from articles.views import formulaire_ajouter_medicament, ajouter_article, liste_articles, detail_article  ,afficher_modifier_articles ,valider_modifier_articles ,supprimer_article 
from commandes.views import liste_commandes , affiche_ajouter_commande ,ajouter_commande , afficher_commande   , checkNickName , checkInfoVente,affiche_ajouter_bon_commande,liste_bon_commandes ,ajouter_bn_commande ,afficher_bon_commande,confirme_bon_commande ,convertir_en_facture_fournisseur ,supprimer_commande ,afficher_modifier_commande ,valider_modifier_commande ,afficher_modifier_bon_commande ,valider_modifier_bon_commande ,supprimer_bon_commande ,DownloadPDFCommande ,ViewPDFCommande
from facturesdavoir.views import formulaire_ajouter_facture_avoir, ajouter_facture_avoir ,liste_facture_avoir , detail_facture_avoir, ViewPDF , DownloadPDF ,supprimer_facturedavoir ,marquer_comme_ouvert ,formulaire_ajouter_facture_avoir_nouveau ,ajouter_facture_avoir_nouveau
from factures.views import ajouter_facture ,liste_facture ,afficher_facture  ,affiche_ajouter_facture ,ajouter_facture , ajouter_facture_non_commandee ,marquer_comme_envoye ,marquer_comme_expedie,ajouter_facture_fournisseur,liste_facture_fournisseur,afficher_facture_fournisseur,convertir_en_ouvert ,ajouter_facture_fournisseur_non_commandee,affiche_ajouter_facture_fournisseur,afficher_modifier_facture ,valider_modifier_facture ,supprimer_facture ,supprimer_facture_fournisseur,afficher_modifier_facture_fournisseur ,valider_modifier_facture_fournisseur ,ViewPDFFacture,DownloadPDFFacture ,DownloadPDFFactureFournisseur , ViewPDFFactureFournisseur ,getNumFacture
from paiements.views import afficher_ajouter_paiement , ajouter_paiement ,afficher_ajouter_paiement_facture_fournisseur ,ajouter_paiement_facture_fournisseur ,liste_paiement_recu ,liste_paiement_effectues ,afficher_paiement ,afficher_ajouter_paiement_nouveau ,getFactureClient,ajouter_paiement_nouveau,getFactureFournisseur,afficher_ajouter_paiement_fournisseur_nouveau,ajouter_paiement_fournisseur_nouveau ,afficher_modifier_paiement ,valider_modifier_paiement ,supprimer_paiement ,valider_modifier_paiement_nouveau ,DownloadPDFPaiement ,ViewPDFPaiement
from colis.views import affiche_ajouter_colis ,ajouter_colis ,afficher_liste_colis ,afficher_colis ,afficher_ajouter_colis_colis ,getArticleCommande ,afficher_modifier_colis , supprimer_colis ,valider_modifier_colis ,ViewPDFColis ,DownloadPDFColis
from django.conf.urls import url
from livraison.views import afficher_ajouter_expidition ,ajouter_expidition,enregistrer_livraison,supprimer_livraison ,marquer_non_livre
from ajustementsstocks.views import liste_ajustement_stock, formulaire_ajuster_stockage, ajuster_stock ,supprimer_stock
from retours.views import formulaire_retour_sur_ventes, ajouter_retour_sur_ventes, liste_retours, detail_retour, refuser_retour, approuver_retour ,modifier_retour_sur_ventes ,valider_modifier_retour_sur_ventes ,supprimer_retour_sur_ventes
from fournisseurs.views import liste_fournisseurs,affiche_ajouter_fournisseur,ajouter_fournisseur ,afficher_fournisseur ,affiche_modifier_fournisseur,valider_modifier_fournisseur,supprimer_fournisseur ,afficher_fournisseur_fnct
from avisreceptions.views import formulaire_avis_reception, ajouter_avis_de_reception, detail_avis_reception ,modifier_avis_reception_retour ,valider_modifier_avis_reception_retour ,supprimer_avis_reception_retour
from my_app.views import (
    indexView,
    postFriend,
    checkNickName1, 
)
from facturesdavoirfournisseurs.views import liste_facture_avoir_fournisseur ,detail_facture_avoir_fournisseur ,formulaire_ajouter_facture_avoir_fournisseur ,ajouter_facture_avoir_fournisseur ,marquer_comme_ouvert_facturefournisseur ,supprimer_facturedavoirfournisseur ,ViewPDFFF ,DownloadPDFFF
from avisderecu.views import affiche_ajouter_avis_recu ,ajouter_aviderecu ,affiche_avis_reception ,modifier_avis_reception ,valider_modifier_aviderecu ,supprimer_aviderecu
from remboursements.views import afficher_ajouter_remboursements ,ajouter_remboursements ,supprimer_remboursements ,afficher_modifier_remboursement ,valider_modifier_remboursement
from dashboard.views import afficherDashboard ,datefiltre ,getdetails ,getdetailsdatefiltre ,getdetailscountcommande ,getdetailsdatecommandefiltre
from django.conf import settings
from django.views.static import serve
from django.conf.urls import url
urlpatterns = [
    path('pdf_view/', ViewPDF.as_view(), name="pdf_view"),
    path('downoald_pdf_view/', DownloadPDF.as_view(), name="downoald_pdf"),
    path('pdf_view_facture/', ViewPDFFacture.as_view(), name="pdf_view_facture"),
    path('downoald_pdf_facture_view/', DownloadPDFFacture.as_view(), name="downoald_pdf_facture"),
    path('pdf_view_colis/', ViewPDFColis.as_view(), name="pdf_view_colis"),
    path('downoald_pdf_colis_view/', DownloadPDFColis.as_view(), name="downoald_pdf_colis"),
    path('pdf_view_paiement/', ViewPDFPaiement.as_view(), name="pdf_view_paiement"),
    path('downoald_pdf_paiement_view/', DownloadPDFPaiement.as_view(), name="downoald_pdf_paiement"),
    path('pdf_view_facture_fournisseur/', ViewPDFFactureFournisseur.as_view(), name="ViewPDFFactureFournisseur"),
    path('downoald_pdf_facture_fournsseur_view/', DownloadPDFFactureFournisseur.as_view(), name="DownloadPDFFactureFournisseur"),
    path('pdf_view_commande/', ViewPDFCommande.as_view(), name="pdf_view_commande"),
    path('downoald_pdf_commande_view/', DownloadPDFCommande.as_view(), name="downoald_pdf_commande"),
    path('pdf_factAvFour_view/', ViewPDFFF.as_view(), name="pdf_view_fact_av_four"),
    path('downoald_pdf_factAvFour_view/', DownloadPDFFF.as_view(), name="downoald_pdf_fact_av_four"),
    path('admin/', admin.site.urls),  # Django admin route
    path('customers/', include("customers.urls")),  # Django customers route
    path("", include("app.urls")),  # UI Kits Html files
    
    path("", include("authentication.urls")),  # Auth routes - login / register ajouter_facture_avoir*
    path('ajouter_facture_avoir', ajouter_facture_avoir, name="ajouter_facture_avoir"),
    path('liste_facture_avoir', liste_facture_avoir, name="liste_facture_avoir"),
    path('detail_facture_avoir', detail_facture_avoir, name="detail_facture_avoir"),
    path('liste_clients', liste_clients, name="liste_clients"),
    path('ajuster_stock', ajuster_stock, name="ajuster_stock"),

    path('indexview', indexView, name = "indexview"),
    path('post/ajax/friend', postFriend, name = "post_friend"),
    path('get/ajax/validate/nickname1', checkNickName1, name = "validate_nickname1"),

    path('ajouter_avis_de_reception', ajouter_avis_de_reception, name="ajouter_avis_de_reception"),
    path('detail_avis_reception', detail_avis_reception, name="detail_avis_reception"),
    path('formulaire_avis_reception', formulaire_avis_reception, name="formulaire_avis_reception"),
    path('formulaire_retour_sur_ventes', formulaire_retour_sur_ventes, name="formulaire_retour_sur_ventes"),
    path('liste_retours', liste_retours, name="liste_retours"),
    path('detail_retour', detail_retour, name="detail_retour"),
    path('refuser_retour', refuser_retour, name="refuser_retour"),
    path('approuver_retour', approuver_retour, name="approuver_retour"),
    path('liste_ajustement_stock', liste_ajustement_stock, name="liste_ajustement_stock"),
    path('formulaire_ajuster_stockage', formulaire_ajuster_stockage, name="formulaire_ajuster_stockage"),
    path('valider_lot', valider_lot, name="valider_lot"),
    path('ajouter_client', ajouter_client, name="ajouter_client"),
    path('liste_articles', liste_articles, name="liste_articles"),
    path('ajouter_lots', ajouter_lots, name="ajouter_lots"),
    path('affiche_ajouter_client', affiche_ajouter_client, name="affiche_ajouter_client"),
    path('afficher_organisation', afficher_organisation, name="afficher_organisation"),
    path('ajouter_organisation', ajouter_organisation, name="ajouter_organisation"),
    path('formulaire_ajouter_medicament', formulaire_ajouter_medicament, name="formulaire_ajouter_medicament"),
    path('liste_commandes', liste_commandes, name="liste_commandes"),
    path('affiche_ajouter_commande', affiche_ajouter_commande, name="affiche_ajouter_commande"),
    path('ajouter_commande', ajouter_commande, name="ajouter_commande"),
    path('ajouter_article', ajouter_article, name="ajouter_article"),
    path('liste_lots_d_article', liste_lots_d_article, name="liste_lots_d_article"),
    path('formulaire_ajouter_facture_avoir', formulaire_ajouter_facture_avoir, name="formulaire_ajouter_facture_avoir"),
    path('liste_d_entree', liste_d_entree, name="liste_d_entree"),
    path('liste_des_lots', liste_des_lots, name="liste_des_lots"),
    path('detail_article', detail_article, name="detail_article"),
    path('afficher_commande', afficher_commande, name="afficher_commande"),
    path('ajouter_facture', ajouter_facture, name="ajouter_facture"),
    path('liste_facture', liste_facture, name="liste_facture"),
    path('afficher_facture', afficher_facture, name="afficher_facture"),
    path('afficher_ajouter_paiement', afficher_ajouter_paiement, name="afficher_ajouter_paiement"),
    path('ajouter_paiement', ajouter_paiement, name="ajouter_paiement"),
    path('affiche_ajouter_facture', affiche_ajouter_facture, name="affiche_ajouter_facture"),
    path('ajouter_facture', ajouter_facture, name="ajouter_facture"),
    path('ajouter_facture_non_commandee', ajouter_facture_non_commandee, name="ajouter_facture_non_commandee"),
    path('afficher_client', afficher_client, name="afficher_client"),
    path('liste_lots',liste_lots, name="liste_lots"),
    path('lots_par',lots_par, name="lots_par"),
    path('get/ajax/validate/nickname', checkNickName, name = "validate_nickname"),
    path('get/ajax/validate/infovente', checkInfoVente, name = "validate_infovente"),
    path('affiche_ajouter_colis', affiche_ajouter_colis, name = "affiche_ajouter_colis"),
    path('ajouter_colis', ajouter_colis, name = "ajouter_colis"),
    path('afficher_liste_colis', afficher_liste_colis, name = "afficher_liste_colis"),
    path('afficher_colis', afficher_colis, name = "afficher_colis"),
    path('ajouter_expidition', ajouter_expidition, name = "ajouter_expidition"),
    path('enregistrer_livraison', enregistrer_livraison, name = "enregistrer_livraison"), 
    path('ajouter_retour_sur_ventes', ajouter_retour_sur_ventes, name = "ajouter_retour_sur_ventes"),
    path('marquer_comme_envoye', marquer_comme_envoye, name = "marquer_comme_envoye"),
    path('marquer_comme_expedie', marquer_comme_expedie, name = "marquer_comme_expedie"),
    path('afficher_ajouter_colis_colis', afficher_ajouter_colis_colis, name = "afficher_ajouter_colis_colis"),
    path('get/ajax/validate/id_commande', getArticleCommande, name = "getArticleCommande"),
    url(r'^afficher_colis/(?P<id_colis>\w+)/$', afficher_colis, name='afficher_colis'),
    url(r'^ajouter_expidition/(?P<id_colis>\w+)/$', afficher_ajouter_expidition, name='afficher_ajouter_expidition'),
    path('liste_fournisseurs', liste_fournisseurs, name='liste_fournisseurs'),
    path('affiche_ajouter_fournisseur', affiche_ajouter_fournisseur, name='affiche_ajouter_fournisseur'),
    path('ajouter_fournisseur', ajouter_fournisseur, name='ajouter_fournisseur'),
    path('affiche_ajouter_bon_commande', affiche_ajouter_bon_commande, name='affiche_ajouter_bon_commande'),
    path('liste_bon_commandes', liste_bon_commandes, name='liste_bon_commandes'),
    path('ajouter_bn_commande', ajouter_bn_commande, name='ajouter_bn_commande'),
    path('afficher_bon_commande', afficher_bon_commande, name='afficher_bon_commande'),
    path('confirme_bon_commande', confirme_bon_commande, name='confirme_bon_commande'),
    path('affiche_ajouter_avis_recu', affiche_ajouter_avis_recu, name='affiche_ajouter_avis_recu'),
    path('ajouter_aviderecu', ajouter_aviderecu, name='ajouter_aviderecu'),
    path('convertir_en_facture_fournisseur', convertir_en_facture_fournisseur, name='convertir_en_facture_fournisseur'),
    path('ajouter_facture_fournisseur', ajouter_facture_fournisseur, name='ajouter_facture_fournisseur'),
    path('afficher_facture_fournisseur', afficher_facture_fournisseur, name='afficher_facture_fournisseur'),
    path('liste_facture_fournisseur', liste_facture_fournisseur, name='liste_facture_fournisseur'),
    path('convertir_en_ouvert', convertir_en_ouvert, name='convertir_en_ouvert'),
    path('afficher_ajouter_paiement_facture_fournisseur', afficher_ajouter_paiement_facture_fournisseur, name='afficher_ajouter_paiement_facture_fournisseur'),
    path('ajouter_paiement_facture_fournisseur', ajouter_paiement_facture_fournisseur, name='ajouter_paiement_facture_fournisseur'),
    path('affiche_avis_reception', affiche_avis_reception, name='affiche_avis_reception'),
    path('liste_paiement_effectues', liste_paiement_effectues, name='liste_paiement_effectues'),
    path('liste_paiement_recu', liste_paiement_recu, name='liste_paiement_recu'),
    path('afficher_paiement', afficher_paiement, name='afficher_paiement'),
    path('afficher_ajouter_paiement_nouveau', afficher_ajouter_paiement_nouveau, name='afficher_ajouter_paiement_nouveau'),
    path('get/ajax/validate/id_client', getFactureClient, name = "getFactureClient"),
    path('ajouter_paiement_nouveau', ajouter_paiement_nouveau, name = "ajouter_paiement_nouveau"),
    path('afficher_ajouter_paiement_fournisseur_nouveau', afficher_ajouter_paiement_fournisseur_nouveau, name = "afficher_ajouter_paiement_fournisseur_nouveau"),
    path('ajouter_paiement_fournisseur_nouveau', ajouter_paiement_fournisseur_nouveau, name = "ajouter_paiement_fournisseur_nouveau"),
    path('ajouter_facture_fournisseur_non_commandee', ajouter_facture_fournisseur_non_commandee, name = "ajouter_facture_fournisseur_non_commandee"),
    path('affiche_ajouter_facture_fournisseur', affiche_ajouter_facture_fournisseur, name = "affiche_ajouter_facture_fournisseur"),
    path('valider_modifier_client', valider_modifier_client, name = "valider_modifier_client"),
    path('affiche_modifier_client', affiche_modifier_client, name = "affiche_modifier_client"),
    path('get/ajax/validate/id_fournisseur', getFactureFournisseur, name = "getFactureFournisseur"),
    path('supprimer_client', supprimer_client, name = "supprimer_client"),
    path('supprimer_commande', supprimer_commande, name = "supprimer_commande"),
    path('afficher_modifier_commande', afficher_modifier_commande, name = "afficher_modifier_commande"),
    path('valider_modifier_commande', valider_modifier_commande, name = "valider_modifier_commande"),
    path('afficher_modifier_facture', afficher_modifier_facture, name = "afficher_modifier_facture"),
    path('valider_modifier_facture', valider_modifier_facture, name = "valider_modifier_facture"),
    path('supprimer_facture', supprimer_facture, name = "supprimer_facture"),
    path('supprimer_facture_fournisseur', supprimer_facture_fournisseur, name = "supprimer_facture_fournisseur"),
    path('afficher_modifier_paiement', afficher_modifier_paiement, name = "afficher_modifier_paiement"),
    path('valider_modifier_paiement', valider_modifier_paiement, name = "valider_modifier_paiement"),
    path('supprimer_paiement', supprimer_paiement, name = "supprimer_paiement"),
    path('valider_modifier_paiement_nouveau', valider_modifier_paiement_nouveau, name = "valider_modifier_paiement_nouveau"),
    path('supprimer_colis', supprimer_colis, name = "supprimer_colis"),
    path('afficher_modifier_colis', afficher_modifier_colis, name = "afficher_modifier_colis"),
    path('valider_modifier_colis', valider_modifier_colis, name = "valider_modifier_colis"),
    path('supprimer_livraison', supprimer_livraison, name = "supprimer_livraison"),
    path('marquer_non_livre', marquer_non_livre, name = "marquer_non_livre"),
    path('afficher_modifier_bon_commande', afficher_modifier_bon_commande, name = "afficher_modifier_bon_commande"),
    path('valider_modifier_bon_commande', valider_modifier_bon_commande, name = "valider_modifier_bon_commande"),
    path('supprimer_bon_commande', supprimer_bon_commande, name = "supprimer_bon_commande"),
    path('afficher_modifier_facture_fournisseur', afficher_modifier_facture_fournisseur, name = "afficher_modifier_facture_fournisseur"),
    path('valider_modifier_facture_fournisseur', valider_modifier_facture_fournisseur, name = "valider_modifier_facture_fournisseur"),
    path('modifier_avis_reception', modifier_avis_reception, name = "modifier_avis_reception"),
    path('valider_modifier_aviderecu', valider_modifier_aviderecu, name = "valider_modifier_aviderecu"),
    path('supprimer_aviderecu', supprimer_aviderecu, name = "supprimer_aviderecu"),
    path('afficher_fournisseur', afficher_fournisseur, name = "afficher_fournisseur"),
    path('gfd/<f_id>/', afficher_fournisseur_fnct, name = "afficher_fournisseur_fnct"),

    #url(r'^afficher_fournisseur/(?P<user_id>\w+)/$', afficher_fournisseur_fnct, name='afficher_fournisseur_fnct'),
    path('affiche_modifier_fournisseur', affiche_modifier_fournisseur, name = "affiche_modifier_fournisseur"),
    path('valider_modifier_fournisseur', valider_modifier_fournisseur, name = "valider_modifier_fournisseur"),
    path('supprimer_fournisseur', supprimer_fournisseur, name = "supprimer_fournisseur"),
    path('modifier_retour_sur_ventes', modifier_retour_sur_ventes, name = "modifier_retour_sur_ventes"),
    path('valider_modifier_retour_sur_ventes', valider_modifier_retour_sur_ventes, name = "valider_modifier_retour_sur_ventes"),
    path('valider_modifier_retour_sur_ventes', valider_modifier_retour_sur_ventes, name = "valider_modifier_retour_sur_ventes"),
    path('supprimer_retour_sur_ventes', supprimer_retour_sur_ventes, name = "supprimer_retour_sur_ventes"),
    path('modifier_avis_reception_retour', modifier_avis_reception_retour, name = "modifier_avis_reception_retour"),
    path('valider_modifier_avis_reception_retour', valider_modifier_avis_reception_retour, name = "valider_modifier_avis_reception_retour"),
    path('supprimer_avis_reception_retour', supprimer_avis_reception_retour, name = "supprimer_avis_reception_retour"),
    path('afficher_modifier_articles', afficher_modifier_articles, name = "afficher_modifier_articles"),
    path('valider_modifier_articles', valider_modifier_articles, name = "valider_modifier_articles"),
    path('supprimer_article', supprimer_article, name = "supprimer_article"),
    path('afficher_modifier_lot', afficher_modifier_lot, name = "afficher_modifier_lot"),
    path('valider_modifier_lot', valider_modifier_lot, name = "valider_modifier_lot"),
    path('Supprimer_lot', Supprimer_lot, name = "Supprimer_lot"),
    path('detail_lot', detail_lot, name = "detail_lot"),
    path('ajouter/remboursement', afficher_ajouter_remboursements, name = "afficher_ajouter_remboursements"),
    path('ajouter/remboursement/valide', ajouter_remboursements, name = "ajouter_remboursements"),
    path('ajouter/remboursement/supprimer', supprimer_remboursements, name = "supprimer_remboursements"),
    path('ajouter/remboursement/modifier', afficher_modifier_remboursement, name = "afficher_modifier_remboursement"),
    path('ajouter/remboursement/modifier/valide', valider_modifier_remboursement, name = "valider_modifier_remboursement"),
    path('supprimer/facturedavoir', supprimer_facturedavoir, name = "supprimer_facturedavoir"),  
    path('marqueouver/facturedavoir', marquer_comme_ouvert, name = "marquer_comme_ouvert"),  
    path('ajouter/Nouveau/facturedavoir', formulaire_ajouter_facture_avoir_nouveau, name = "formulaire_ajouter_facture_avoir_nouveau"),  
    path('ajouter/Nouveau/facturedavoir/valider', ajouter_facture_avoir_nouveau, name = "ajouter_facture_avoir_nouveau"), 
    path('facturesdavoirfournisseurs', liste_facture_avoir_fournisseur, name = "liste_facture_avoir_fournisseur"), 
    path('details/facturesdavoirfournisseurs', detail_facture_avoir_fournisseur, name = "detail_facture_avoir_fournisseur"), 
    path('ajouter/facturesdavoirfournisseurs', formulaire_ajouter_facture_avoir_fournisseur, name = "formulaire_ajouter_facture_avoir_fournisseur"), 
    path('ajouter/facturesdavoirfournisseurs/valider', ajouter_facture_avoir_fournisseur, name = "ajouter_facture_avoir_fournisseur"),
    path('supprimer/facturesdavoirfournisseurs', supprimer_facturedavoirfournisseur, name = "supprimer_facturedavoirfournisseur"),
    path('marque/ouvert/facturesdavoirfournisseurs', marquer_comme_ouvert_facturefournisseur, name = "marquer_comme_ouvert_facturefournisseur"),
    path('dashboard', afficherDashboard, name = "afficherDashboard"),
    path('datefiltre', datefiltre, name = "datefiltre"),
    path('Num/Fcature/id_facture', getNumFacture, name = "getNumFacture"),
    path('get/ajax/validate/choix', getdetails, name = "getdetails"),
    path('get/ajax/validate/filtrepardate', getdetailsdatefiltre, name = "getdetailsdatefiltre"),
    path('getdetailscountcommande', getdetailscountcommande, name = "getdetailscountcommande"),
    path('getdetailsdatecommandefiltre', getdetailsdatecommandefiltre, name = "getdetailsdatecommandefiltre"),
    path('supprimer_stock', supprimer_stock, name = "supprimer_stock"),
    url(r'^media/(?P<path>.*)$', serve,{'document_root': settings.MEDIA_ROOT}),
    url(r'^static/(?P<path>.*)$', serve,{'document_root': settings.STATIC_ROOT }),
    ]

if settings.DEVEL:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
