from django.shortcuts import render ,redirect
from facturesdavoirfournisseurs.models import Facture_d_avoir_fournisseur
from detailsfacturedavoirfournisseurs.models import DetailFactureAvoirFournisseur
from fournisseurs.models import Fournisseur
from articles.models import Article
from lots.models import Lot
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from remboursements.models import Remboursement
import decimal
from django.urls import reverse
from urllib.parse import urlencode
from io import BytesIO
from django.http import HttpResponse
from django.template.loader import get_template
from django.views import View
from xhtml2pdf import pisa
from datetime import date
# Create your views here.

def render_to_pdf(template_src, context_dict={}):
	template = get_template(template_src)
	html  = template.render(context_dict)
	result = BytesIO()
	print("result" , result)
	pdf = pisa.pisaDocument(BytesIO(html.encode("cp1252")), result)
	if not pdf.err:
		return HttpResponse(result.getvalue(), content_type='application/pdf')
	return None

class ViewPDFFF(View):
	def get(self, request, *args, **kwargs):
		id_facture = request.GET.get('id_facture')
		print('id ',id_facture)
		data = {
			"facture": Facture_d_avoir_fournisseur.objects.get(id = id_facture),
			"detail_facture": DetailFactureAvoirFournisseur.objects.filter(facture_avoir_id = id_facture),
		}
		pdf = render_to_pdf('facture-avoir-fournisseur.html', data)
		return HttpResponse(pdf, content_type='application/pdf')

class DownloadPDFFF(View):
	def get(self, request,*args,**kwargs):
		id_facture = request.GET.get('id_facture')
		print('id ',id_facture)
		data = {
			"facture": Facture_d_avoir_fournisseur.objects.get(id = id_facture),
			"detail_facture": DetailFactureAvoirFournisseur.objects.filter(facture_avoir_id = id_facture),
		}
		pdf = render_to_pdf('facture-avoir-fournisseur.html',data)
		#filename = "Invoice_%s.pdf" %("12341231")
		content = "attachment; filename= facture-avoir-fournisseur.pdf"
		response = HttpResponse(pdf,content_type = 'application/pdf')
		response['Content-Disposition'] = content
		return response
		
@login_required(login_url="/login/")	
def liste_facture_avoir_fournisseur(request):
	context = {}
	context['segment'] ='factureavoirfournisseur'
	context['listes_facture_avoir_fournisseur'] = Facture_d_avoir_fournisseur.objects.all().order_by('created_at').reverse()

	return render(request, 'liste-avoir-fournisseur.html', context)

@login_required(login_url="/login/")	
def detail_facture_avoir_fournisseur(request):
	context = {}
	if request.method == "POST":
		id_facture_davoir = request.POST.get('id_facture_davoir')
	else : 
		id_facture_davoir = request.GET.get('000')	

	context['details_facture'] = DetailFactureAvoirFournisseur.objects.filter(facture_avoir_id = id_facture_davoir)
	context['facture'] = Facture_d_avoir_fournisseur.objects.get(id = id_facture_davoir)
	#context['remboursements'] = Remboursement.objects.filter(Facture_d_avoir_fournisseur_id = id_facture_davoir)
	remboursements = Remboursement.objects.filter(Facture_d_avoir_fournisseur_id = id_facture_davoir)
	total_m = 0
	if remboursements :
		for r in remboursements :
			total_m = total_m + r.montant

	context['remboursements'] = remboursements
	context['total_m'] = total_m

	if Facture_d_avoir_fournisseur.objects.get(id = id_facture_davoir).statut == 'Brouillon':
		numf = Facture_d_avoir_fournisseur.objects.all().exclude(id = id_facture_davoir).exclude(num_facture = 0).order_by('date').reverse().first()
		if numf  :
			context['num_facture']  = '00'+ str(int(numf.num_facture_avoir) + 1)
		else :
			context['num_facture']   = '001'
	
	context['now'] = date.today()
	return render(request, 'details-facture-avoir-fournisseur.html', context)

@login_required(login_url="/login/")	
def formulaire_ajouter_facture_avoir_fournisseur(request):
	context = {}

	context['liste_fournisseurs'] = Fournisseur.objects.filter(status ='actif')
	context['liste_articles'] = Article.objects.all()
	id_f = Facture_d_avoir_fournisseur.objects.all().order_by('created_at').reverse().first()
	if id_f  :
		context['num_facture'] = '00'+ str(id_f.id)
	else : 
		context['num_facture'] = '00'
	return render(request, 'ajouter-facture-avoir-fournisseur-nouveau.html', context)


@login_required(login_url="/login/")	
def ajouter_facture_avoir_fournisseur(request):
	context = {}
	if request.method == "POST":
		id_fournisseur = request.POST.get('fournisseur')
		numero_facture_avoir = request.POST.get('numero_facture_avoir')
		date_facture_avoir = request.POST.get('date_facture_avoir')
		article_options = request.POST.getlist('article_options[]')
		#lot_options = request.POST.getlist('lots_options[]')
		qantite_options = request.POST.getlist('qantite_options[]')
		taux_options = request.POST.getlist('taux_options[]')
		taxe_options = request.POST.getlist('taxe_options[]')
		montant_options = request.POST.getlist('montant_options[]')
		sous_total = request.POST.get('sous_total')
		remise = request.POST.get('remise')
		total = request.POST.get('total')
		note = request.POST.get('note')


	facture_obj = Facture_d_avoir_fournisseur(fournisseur_id = id_fournisseur, num_facture = numero_facture_avoir
	, date = date_facture_avoir, remise = remise, sous_total = sous_total, total = total,note = note , reste = total)
	facture_obj.save()
	print( 'article obj ',article_options)
	for i in range(len(article_options)):
		article_id = article_options[i].split()[0]
		articel_fact = Article.objects.get(id = article_id)
		# lo_id = lot_options[i].split()[0]
		# lot_fact = Lot.objects.get(id = lo_id)
		objet_facturee = DetailFactureAvoirFournisseur(facture_avoir = facture_obj,quantitee = qantite_options[i], taux = taux_options[i], taxe = taxe_options[i], montant = montant_options[i],
			article = articel_fact)

		new_stock_comptable_disponible = articel_fact.stock_comptable_disponible - decimal.Decimal(qantite_options[i])
		Article.objects.filter(id = articel_fact.id).update(stock_comptable_disponible = new_stock_comptable_disponible)

		new_quantitee_non_declarer_comme_lot = articel_fact.quantitee_non_declarer_comme_lot - decimal.Decimal(qantite_options[i])
		Article.objects.filter(id = articel_fact.id).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)
		objet_facturee.save()

	messages.success(request, "Facture d'avoir Fournisseur a été bien enregistré")
	return redirect('formulaire_ajouter_facture_avoir_fournisseur')

@login_required(login_url="/login/")	
def marquer_comme_ouvert_facturefournisseur(request):
	context = {}
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		num_facture = request.POST.get('num_facture')
		facture = Facture_d_avoir_fournisseur.objects.get(id = id_facture)
		if facture.statut == 'Brouillon' :
			Facture_d_avoir_fournisseur.objects.filter(id = id_facture).update(statut = "Ouvert")
			Facture_d_avoir_fournisseur.objects.filter(id = id_facture).update(num_facture = num_facture)
			detailRetourFacture = DetailFactureAvoirFournisseur.objects.filter(facture_avoir=facture)


			for i in range(len(detailRetourFacture)):
				article = detailRetourFacture[i].article.id
				stock_comptable_disponible_ancien = Article.objects.get(id = article).stock_comptable_disponible
				stock_physique_comptable_a_la_vente_ancien = Article.objects.get(id = article).stock_comptable_disponible_a_la_vente
				quantitee_non_declarer_comme_lot_ancien = Article.objects.get(id = article).quantitee_non_declarer_comme_lot

				Article.objects.filter(id = article).update(stock_comptable_disponible = stock_comptable_disponible_ancien - detailRetourFacture[i].quantitee)
				Article.objects.filter(id = article).update(stock_comptable_disponible_a_la_vente = stock_physique_comptable_a_la_vente_ancien - detailRetourFacture[i].quantitee )
				Article.objects.filter(id = article).update(quantitee_non_declarer_comme_lot = quantitee_non_declarer_comme_lot_ancien - detailRetourFacture[i].quantitee)
				
				# lot = detailRetourFacture[i].lot.id
				# quantitee_ancien = Lot.objects.get(id = lot).quantitee
				# Lot.objects.filter(id = lot).update(quantitee = quantitee_ancien - detailRetourFacture[i].quantitee)

				stock_physique_disponible_ancien = Article.objects.get(id = article).stock_physique_disponible
				stock_physique_disponible_a_la_vente_ancien = Article.objects.get(id = article).stock_physique_disponible_a_la_vente
				Article.objects.filter(id = article).update(stock_physique_disponible = stock_physique_disponible_ancien - detailRetourFacture[i].quantitee)
				Article.objects.filter(id = article).update(stock_physique_disponible_a_la_vente = stock_physique_disponible_a_la_vente_ancien - detailRetourFacture[i].quantitee )

			messages.success(request, 'facture a été marque comme ouvert')
		else:
			messages.info(request, 'facture a été deja marque comme ouvert')
		base_url = reverse('detail_facture_avoir_fournisseur')  # 1 /products/
		query_string =  urlencode({'000': id_facture})  # 2 category=42
		url = '{}?{}'.format(base_url, query_string)  # 3 /products/?category=42
	return redirect(url)


login_required(login_url="/login/")
def supprimer_facturedavoirfournisseur(request):
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		facture = Facture_d_avoir_fournisseur.objects.get(id = id_facture)
		detailRetourFacture = DetailFactureAvoirFournisseur.objects.filter(facture_avoir=facture)

		if facture.reste == facture.total  :	
			for i in range(len(detailRetourFacture)):
					article = detailRetourFacture[i].article.id
					# lot = detailRetourFacture[i].lot.id
					# quantitee_ancien = Lot.objects.get(id = lot).quantitee
					# Lot.objects.filter(id = lot).update(quantitee = quantitee_ancien - detailRetourFacture[i].quantitee)
					stock_comptable_disponible_ancien = Article.objects.get(id = article).stock_comptable_disponible
					quantitee_non_declarer_comme_lot_ancien = Article.objects.get(id = article).quantitee_non_declarer_comme_lot
					Article.objects.filter(id = article).update(stock_comptable_disponible = stock_comptable_disponible_ancien + detailRetourFacture[i].quantitee)
					Article.objects.filter(id = article).update(quantitee_non_declarer_comme_lot = quantitee_non_declarer_comme_lot_ancien + detailRetourFacture[i].quantitee)

			facture.delete()
			messages.info(request , 'facture bien supprimé')
		else :
			messages.info(request, 'Ce contact ne peut pas être supprimé car il est associé à des transactions ou des documents')
			base_url = reverse('detail_facture_avoir_fournisseur')  # 1 /products/
			query_string =  urlencode({'000': id_facture})  # 2 category=42
			url = '{}?{}'.format(base_url, query_string)  # 3 /products/?category=42
			return redirect(url)
	
	return redirect('liste_facture_avoir_fournisseur')	

