from django.shortcuts import render ,redirect
from colis.models import Colis
from livraison.forms import form_validation_error ,LivraisonForm
import decimal
from django.contrib import messages
from livraison.models import Livraison
from commandes.models import Commande
from colis.models import Colis
from articlescommandee.models import ArticleCommandee
from detailscolis.models import DetailsColis
from articles.models import Article
from lots.models import Lot
from django.contrib.auth.decorators import login_required
from facturesdavoir.views import  render_to_pdf
from django.views import View
from xhtml2pdf import pisa
from io import BytesIO
from django.http import HttpResponse
from django.template.loader import get_template
# Create your views here.


@login_required(login_url="/login/")
def afficher_ajouter_expidition(request , id_colis):
	context = {}
	id_colis = int(id_colis)

		
	colis = Colis.objects.get(id = id_colis)
	commande = Commande.objects.get(id = colis.commande.id)
	related_colis = Colis.objects.filter(commande = colis.commande).exclude(id = id_colis).filter(livraison = None).filter(status = 'NON EXPEDIE')
	context['colis'] = colis
	context['related_colis'] = related_colis
	context['id_commande'] = colis.commande.id
	context['commande'] = commande
	livT = Livraison.objects.all().order_by('date').reverse().first()
	if livT  :
		context['num_livraison'] = '00'+ str(int(livT.num_livraison) + 1)
	else :
		context['num_livraison']  = '001'


	return render(request, 'ajouter-expidition.html', context)
@login_required(login_url="/login/")
def ajouter_expidition(request):
	context = {}
	if request.method == "POST":
		form = LivraisonForm(request.POST or None)
		if form.is_valid():
			print("is valid")
			form.save()
			last_livraison = Livraison.objects.last().id
			livraison = Livraison.objects.get(id = last_livraison)
			print( 'id livraison ' , last_livraison , ' livraison ' , livraison)

			Livraison.objects.filter(id = last_livraison).update(etat = "EXPEDIE")
			liste_colis = request.POST.getlist('colis[]')
			qantite = 0 
			for i in range(len(liste_colis)):
				id_colis = liste_colis[i]
				print('colis' ,id_colis)
				colisexp = Colis.objects.get(id = id_colis)

				Colis.objects.filter(id = id_colis).update(livraison = livraison)
				Colis.objects.filter(id = id_colis).update(status = 'EXPEDIE')
				liste_article_colis = DetailsColis.objects.filter(colis = colisexp)
				for j in  range(len(liste_article_colis)):
					qantiteexp = liste_article_colis[j].qantite
					if liste_article_colis[j].articlecommandee.article :
						# change article qantite
						articlexp = liste_article_colis[j].articlecommandee.article.id
						command_id = liste_article_colis[j].articlecommandee.commande.id
						commande =  Commande.objects.get(id = command_id)
						print(articlexp)
						articleExped = Article.objects.get(id = articlexp)
						# new_stock_physique_disponible = articleExped.stock_physique_disponible - qantiteexp
						# new_stock_physique_engage = articleExped.stock_physique_engage - qantiteexp
						# # # change lot qantite
						lotexp = liste_article_colis[j].articlecommandee.lot.id
						lotExped = Lot.objects.get(id = lotexp)
						# new_qantite_lot = lotExped.quantitee - qantiteexp
						# Article.objects.filter(id = articlexp).update(stock_physique_disponible = new_stock_physique_disponible)
						# Article.objects.filter(id = articlexp).update(stock_physique_engage = new_stock_physique_engage)
						# Lot.objects.filter(id = lotexp).update(quantitee = new_qantite_lot)

						art = ArticleCommandee.objects.get(id =liste_article_colis[j].articlecommandee.id)
						new_qt = art.expediee + liste_article_colis[j].qantite
						ArticleCommandee.objects.filter(id =liste_article_colis[j].articlecommandee.id).filter(lot = lotExped).filter(article = articleExped).update(expediee = new_qt)

			id_commande = request.POST.get('id_commande')
			commande = Commande.objects.get(id = id_commande)
			final_list_articla_commande = ArticleCommandee.objects.filter(commande=commande)
			final_list_colis = Colis.objects.filter(commande=commande)

			bol = True
			for c in final_list_colis :
				if c.livraison == None :
					bol = False


			rest_emballee_total = 0
			for arf in final_list_articla_commande :
				rest_emballee_total = rest_emballee_total + arf.reste_emballee 
					
			if rest_emballee_total == 0  :
				if bol == True :
				  Commande.objects.filter(id = id_commande).update(expiditions = 'traite')
				else :
				  Commande.objects.filter(id = id_commande).update(expiditions = 'partiellement expedie')
			else :
				Commande.objects.filter(id = id_commande).update(expiditions = 'partiellement expedie')

			messages.success(request, 'expédition a été bien ajoute')	

	return redirect('afficher_liste_colis')

@login_required(login_url="/login/")
def enregistrer_livraison(request ):
	context = {}
	if request.method == "POST":
		id_colis = request.POST.get('id_colis_select')
		date = request.POST.get('date_livrai')
		colis = Colis.objects.get(id = id_colis)
		livraison = Livraison.objects.get(id = colis.livraison.id)
		Colis.objects.filter(id = id_colis).filter(livraison = livraison).update(status = 'LIVRE')
		
		Livraison.objects.filter(id = livraison.id).update(etat = 'LIVRE')
		Livraison.objects.filter(id = livraison.id).update(date_livraison = date)

		messages.success(request, 'colis a été bien marque comme livre')	

	return redirect('afficher_liste_colis')


@login_required(login_url="/login/")		
def supprimer_livraison(request ):
	if request.method == "POST":
		idcolis = request.POST.get('colis')
		colis = Colis.objects.get(id = idcolis)
		livraison = Livraison.objects.get(id = colis.livraison.id)
		Colis.objects.filter(id = idcolis).update(status = 'NON EXPEDIE')
		liste_article_colis = DetailsColis.objects.filter(colis = colis)
		for j in  range(len(liste_article_colis)):
				qantiteexp = liste_article_colis[j].qantite
				if liste_article_colis[j].articlecommandee.article :
					articlexp = liste_article_colis[j].articlecommandee.article.id
					articleExped = Article.objects.get(id = articlexp)

					lotexp = liste_article_colis[j].articlecommandee.lot.id
					lotExped = Lot.objects.get(id = lotexp)

					art = ArticleCommandee.objects.get(id =liste_article_colis[j].articlecommandee.id)
					new_qt = art.expediee - liste_article_colis[j].qantite
					ArticleCommandee.objects.filter(id =liste_article_colis[j].articlecommandee.id).filter(lot = lotExped).filter(article = articleExped).update(expediee = new_qt)
		
		if  Colis.objects.filter(livraison = colis.livraison).exclude(id = idcolis ).exists():
			Colis.objects.filter(id = idcolis).update(livraison = None)
		else : 	
			livraison.delete()
			
		id_commande = request.POST.get('id_commande')
		commande = Commande.objects.get(id = colis.commande.id)
		final_list_articla_commande = ArticleCommandee.objects.filter(commande=commande)
		final_list_colis = Colis.objects.filter(commande=commande)

		bol = True
		liv = False
		for c in final_list_colis :
			if c.livraison == None :
				bol = False
			else : 
				liv = True



		rest_emballee_total = 0
		qantitetotal = 0
		for arf in final_list_articla_commande :
			rest_emballee_total = rest_emballee_total + arf.reste_emballee 
			qantitetotal = qantitetotal + arf.qantite_total
					
		if rest_emballee_total == 0 :
			if bol == True :
				Commande.objects.filter(id = commande.id).update(expiditions = 'traite')
			else :
				Commande.objects.filter(id = commande.id).update(expiditions = 'partiellement expedie')
		else :
			if liv ==  False :
				Commande.objects.filter(id = commande.id).update(expiditions = 'non expedie')
			else :	
				Commande.objects.filter(id = commande.id).update(expiditions = 'partiellement expedie')
		
		messages.success(request, 'livraison a été bien supprimer')	
	return redirect('afficher_liste_colis')	


@login_required(login_url="/login/")
def marquer_non_livre(request ):
	context = {}
	if request.method == "POST":
		id_colis = request.POST.get('colis')
		colis = Colis.objects.get(id = id_colis)
		livraison = Livraison.objects.get(id = colis.livraison.id)

		Colis.objects.filter(id = id_colis).update(status = 'EXPEDIE')
		
		Livraison.objects.filter(id = livraison.id).update(etat = 'EXPEDIE')
		Livraison.objects.filter(id = livraison.id).update(date_livraison = None)

		messages.success(request, 'colis a été bien marque comme Non livre')	

	return redirect('afficher_liste_colis')

