from django.shortcuts import render ,redirect
from factures.models import Facture
from articlescommandeefactures.models import Articlescommandeefactures
from organisation.models import Organisation
from paiements.models import Paiement
from paiements.forms import PaiementForm , form_validation_error
import decimal
from commandes.models import Commande
from django.contrib import messages
from articlescommandee.models import ArticleCommandee
from articles.models import Article
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from clients.models import Client
from django.http import JsonResponse
from django.http import HttpResponse
from django.core.serializers import serialize
from django.core import serializers
from groupspaiements.models import GroupPaiement
from groupspaiements.forms import GroupPaiementForm ,form_validation_error
from fournisseurs.models import Fournisseur
from detailsgroupspaiement.models import Detailsgrouppaiement
from io import BytesIO
from django.http import HttpResponse
from django.template.loader import get_template
from django.views import View
from xhtml2pdf import pisa
from facturesdavoir.views import  render_to_pdf
from datetime import date
from django.contrib.auth.models import User
from django.contrib.auth.models import Group 
# Create your views here.
@login_required(login_url="/login/")
def afficher_ajouter_paiement(request):
	context = {}
	if request.method == "POST":
		id_commande = request.POST.get('id_commande')
		commande = Commande.objects.get(id = id_commande)
		context['commande'] = commande

		paiements = Paiement.objects.filter(commande = commande)
		montant_payee = 0
		for p in paiements :
			montant_payee = montant_payee +  p.montant

		context['max'] = commande.total
		context['montant_payee'] = montant_payee


	return render(request, 'ajouter-paiement.html', context)

@login_required(login_url="/login/")
def ajouter_paiement(request):
	context = {}
	if request.method == "POST":
		id_commande = request.POST.get('commande')
		
		commande = Commande.objects.get(id = id_commande)
		montant_payee = request.POST.get('montant')
		montant_total = decimal.Decimal(montant_payee)
		
		form = PaiementForm(request.POST or None)
		if form.is_valid():
			print("is valid")
			form.save()
			last_paiement = Paiement.objects.last().id
			paiement = Paiement.objects.get(id = last_paiement)

			Commande.objects.filter(id =  paiement.commande.id).update(reste = commande.reste - montant_total)
			if commande.reste - montant_total == commande.total :
				Commande.objects.filter(id = paiement.commande.id).update(paiement ='impaye')
			elif commande.reste - montant_total == 0  :
				Commande.objects.filter(id = paiement.commande.id).update(paiement ='paye')
			else :
				Commande.objects.filter(id = paiement.commande.id).update(paiement ='partiellement payee')

			messages.success(request, 'paiement a été bien ajouter')	

	#return render(request, 'afficher-facture.html', context)
	return redirect('afficher_ajouter_paiement')
	#return HttpResponseRedirect('afficher_facture')
@login_required(login_url="/login/")
def afficher_ajouter_paiement_facture_fournisseur(request):
	context = {}
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		facture = Facture.objects.get(id = id_facture)
		context['facture'] = facture
		articlecommandeefacture = Articlescommandeefactures.objects.filter(facture=facture)
		paiements = Paiement.objects.filter(facture = facture)
		max_paiement = facture.reste
		for p in paiements :
			if p.cheque :
				if p.cheque.status == 'invalid' :
					max_paiement = max_paiement - p.montant

		context['articlecommandeefacture'] = articlecommandeefacture
		context['max'] = max_paiement


	return render(request, 'ajouter-paiement-facture-fournisseur.html', context)




@login_required(login_url="/login/")
def ajouter_paiement_facture_fournisseur(request):
	context = {}
	if request.method == "POST":
		id_facture = request.POST.get('facture')
		if id_facture != '': 
			facture = Facture.objects.get(id = id_facture)
			montant_payee = request.POST.get('montant')
			montant_total = decimal.Decimal(montant_payee) 
			form = PaiementForm(request.POST or None)
			if form.is_valid():
					print("is valid")
					form.save()
					last_paiement = Paiement.objects.last().id
					paiement = Paiement.objects.get(id = last_paiement)
					mode_paiement = request.POST.get('mode_paiement')
					if mode_paiement == 'Cheque' :
						num_cheque = request.POST.get('num_cheque')
						date_echeance = request.POST.get('date_echeance')
						cheque = Cheque(num_cheque = num_cheque , date_echeance = date_echeance)
						cheque.save()
						Paiement.objects.filter(id = last_paiement).update(cheque = cheque)	
					else :	
						facture_reste = facture.reste - montant_total
						Facture.objects.filter(id = id_facture).update(reste = facture_reste)		
						
						if montant_total < facture.reste :
							if facture.commande : 
								Commande.objects.filter(id = facture.commande.id).update(paiement ='Partiellement payee')
							Facture.objects.filter(id = id_facture).update(status = "Partiellement payee")
						
						elif montant_total == facture.reste :
								Facture.objects.filter(id = id_facture).update(status = "Paye")
								if facture.commande :
									commande = Commande.objects.get(id = facture.commande.id)
									list_facture = Facture.objects.filter(commande = facture.commande)
									reste_facture = 0
									if list_facture :
										for fa in list_facture :
										 	reste_facture  = fa.reste + reste_facture

									if 	reste_facture == 0 and commande.facturee != 'Partiellement facturee': 	
										Commande.objects.filter(id = facture.commande.id).update(paiement ='Paye')
									else :
										Commande.objects.filter(id = facture.commande.id).update(paiement ='Partiellement payee')		
							
					messages.success(request, 'paiement a été bien ajouter')		
		
		else :
			messages.error(request, 'no fcature selected ')	
			return render(request, 'ajouter-paiement-facture-fournisseur.html', context)
	return redirect('liste_facture_fournisseur')	

@login_required(login_url="/login/")
def liste_paiement_effectues(request):
    context = {}
    context['segment'] = 'paiement_effectues'
    context['now'] = date.today()
    liste_paiements = Paiement.objects.all().order_by('date').reverse()
    liste_p = []
    for i in range(len(liste_paiements)): 
    	if liste_paiements[i].commande.type_commande == 'bon_commande' :
    		liste_p.append(liste_paiements[i])	

    gourppaiement = GroupPaiement.objects.all().order_by('date').reverse()
    liste_gp = []
    for i in range(len(gourppaiement)): 
    	liste_f = Detailsgrouppaiement.objects.filter(grouppaiement = gourppaiement[i])
    	if len(liste_f) > 0:
	    	if liste_f[0].commande.type_commande == 'bon_commande' :
	    		liste_gp.append(gourppaiement[i])	

    context['liste_paiements_effectues'] = liste_p
    context['liste_group_paiements'] = liste_gp

    return render(request, 'liste-paiements-effectues.html', context)	

@login_required(login_url="/login/")
def liste_paiement_recu(request):
    context = {}
    context['segment'] = 'paiements'
    context['now'] = date.today()

    liste_paiements = Paiement.objects.all().order_by('date').reverse()
    liste_p = []
    for i in range(len(liste_paiements)): 
    	if liste_paiements[i].commande.type_commande == 'commande' :
    		liste_p.append(liste_paiements[i])	
    
    liste_gp = []
    try :
    	gourppaiement = GroupPaiement.objects.all().order_by('date').reverse()
    	for i in range(len(gourppaiement)):
    		if Detailsgrouppaiement.objects.filter(grouppaiement = gourppaiement[i]).exists():
    			detailsgrouppaiement= Detailsgrouppaiement.objects.filter(grouppaiement = gourppaiement[i]).first()
    			print('detailsgrouppaiement ' ,detailsgrouppaiement)
    			if detailsgrouppaiement.commande.type_commande == 'commande' :
    				liste_gp.append(gourppaiement[i])

    except  GroupPaiement.DoesNotExist :
    	print('not exists')


    context['liste_paiements'] = liste_p
    context['liste_group_paiements'] = liste_gp
    print('liste_gp' ,liste_gp)

    return render(request, 'liste-paiements.html', context)	

@login_required(login_url="/login/")
def afficher_paiement(request):
    context = {}
    if request.method == "POST":
    	id_paiement = request.POST.get('paiement')
    	type_paiement = request.POST.get('type')
    else :
    	id_paiement = request.GET.get('000')
    	type_paiement = request.GET.get('001')

    context['now'] = date.today()
    if type_paiement == "paiement" :
    	paiement = Paiement.objects.get(id = id_paiement)
    	context['paiement'] = paiement

    else :
    	paiement = GroupPaiement.objects.get(id = id_paiement)
    	detailsgroupspaiement =Detailsgrouppaiement.objects.filter(grouppaiement = paiement) 
    	context['paiement'] = paiement
    	context['detailsgroupspaiement'] = detailsgroupspaiement

    context['type'] = type_paiement


    return render(request, 'paiement-effectues.html', context)	

@login_required(login_url="/login/")
def afficher_ajouter_paiement_nouveau(request):
	context = {}
	liste_commande = []
	liste_commande_non_paye = Commande.objects.all().exclude(client = None).exclude(reste = 0 )
	liste_client = []
	for i in range(len(liste_commande_non_paye)):
		if len(liste_client) > 0 :
			for j in range(len(liste_client)):
				if liste_client[j].client.id != liste_commande_non_paye[i].client.id :
					liste_client.append(liste_commande_non_paye[i])
		else :
			liste_client.append(liste_commande_non_paye[i])	

	context['liste_client'] = liste_client
	return render(request, 'ajouter-paiement-nouveau.html', context)    


@login_required(login_url="/login/")
def getFactureClient(request):
	if request.is_ajax and request.method == "GET":
		id_client = request.GET.get("id_client", None)
		id_user = request.GET.get("user", None)

		client = Client.objects.get(id =id_client)
		# facture = Facture.objects.filter(client = client).filter(user = id_user).exclude(reste = 0).exclude(status = 'BROUILLON')
		liste_commande_non_paye = Commande.objects.filter(client = client).exclude(reste = 0)


		data = serialize("json", liste_commande_non_paye)

		if Commande.objects.filter(client = client).exclude(reste = 0).exists() :
			return JsonResponse({"data":data}, status = 200)
		else:
			return JsonResponse({"valid":True}, status = 200)

	return JsonResponse({}, status = 400)


@login_required(login_url="/login/")
def ajouter_paiement_nouveau(request):
	context = {}
	if request.method == "POST":
				liste_commande = request.POST.getlist('facture_options[]')
				liste_paiement = request.POST.getlist('paiement_enrg[]')
				montant_payee = request.POST.get('montant')
				montant_total = decimal.Decimal(montant_payee)

				print(liste_commande)
				print(liste_paiement)

				t = 0 ;
				for j in range(len(liste_paiement)):
					if decimal.Decimal(liste_paiement[j]) > 0:
						t = t + 1;
				if t > 1 :
					form = GroupPaiementForm(request.POST or None)
				elif t == 1 :
					form = PaiementForm(request.POST or None)

				if form.is_valid():
					print("is valid")       
					form.save()
					if t > 1 :
						last_paiement = GroupPaiement.objects.last().id
						paiement = GroupPaiement.objects.get(id = last_paiement)
					elif t == 1 : 
						last_paiement = Paiement.objects.last().id
						paiement = Paiement.objects.get(id = last_paiement)
					
					for i in range(len(liste_commande)):
						if (decimal.Decimal(liste_paiement[i]) > 0) :
							commande = Commande.objects.get(id = liste_commande[i])
							if t > 1 :
								#paiement.facture.add(facture)
								detailsgourppaiement = Detailsgrouppaiement(grouppaiement = paiement, commande = commande , montant = liste_paiement[i] )
								detailsgourppaiement.save()
							elif t == 1 : 
								Paiement.objects.filter(id = last_paiement).update(commande = commande)				
							commande_reste = commande.reste - decimal.Decimal(liste_paiement[i])		
							Commande.objects.filter(id = liste_commande[i]).update(reste = commande_reste)
								
							if  commande_reste == commande.total :
								Commande.objects.filter(id =liste_commande[i]).update(paiement = "impaye")
							elif commande_reste == 0 :
								Commande.objects.filter(id = liste_commande[i]).update(paiement = "paye")
							else :
								Commande.objects.filter(id = liste_commande[i]).update(paiement = "partiellement payee")

					messages.success(request, 'paiement a été bien ajouter')
				else :
					messages.success(request, 'qsdqsdfsf')

	return redirect('liste_paiement_recu')



@login_required(login_url="/login/")
def afficher_ajouter_paiement_fournisseur_nouveau(request):
	context = {}
	liste_fact = Commande.objects.all().exclude(reste = 0).exclude(fournisseur = None)
	liste_fournisseur = []
	for i in range(len(liste_fact)):
		if len(liste_fournisseur) > 0 :
			for j in range(len(liste_fournisseur)):
				if liste_fournisseur[j].fournisseur.id != liste_fact[i].fournisseur.id :
					liste_fournisseur.append(liste_fact[i])
		else :
			liste_fournisseur.append(liste_fact[i])	

	context['liste_facture'] = liste_fournisseur

	return render(request, 'ajouter-paiement-facture-fournisseur-nouveau.html', context)    


@login_required(login_url="/login/")
def getFactureFournisseur(request):
   	if request.is_ajax and request.method == "GET":
   		id_fournisseur = request.GET.get("id_fournisseur", None)
   		fournisseur = Fournisseur.objects.get(id =id_fournisseur)
   		facture = Commande.objects.filter(fournisseur = fournisseur).exclude(reste = 0)
   		data = serialize("json", facture)
   		print(facture)
   		if Commande.objects.filter(fournisseur = fournisseur).exclude(reste = 0).exists():
   			return JsonResponse({"data":data}, status = 200)
   		else:
   			return JsonResponse({"valid":True}, status = 200)
   	return JsonResponse({}, status = 400)




@login_required(login_url="/login/")
def ajouter_paiement_fournisseur_nouveau(request):
	context = {}
	if request.method == "POST":
				liste_facture = request.POST.getlist('facture_options[]')
				liste_paiement = request.POST.getlist('paiement_enrg[]')
				montant_payee = request.POST.get('montant')
				montant_total = decimal.Decimal(montant_payee)
				print(liste_facture)
				print(liste_paiement)
				print(len(liste_paiement))
				t = 0 ;
				for j in range(len(liste_paiement)):
					if decimal.Decimal(liste_paiement[j]) > 0:
						t = t + 1;
				if t > 1 :
					form = GroupPaiementForm(request.POST or None)
				elif t == 1 :
					form = PaiementForm(request.POST or None)

				if form.is_valid():
					print("is valid")       
					form.save()
					if t > 1 :
						last_paiement = GroupPaiement.objects.last().id
						paiement = GroupPaiement.objects.get(id = last_paiement)
					elif t == 1 : 
						last_paiement = Paiement.objects.last().id
						paiement = Paiement.objects.get(id = last_paiement)

					for i in range(len(liste_facture)):
						if (decimal.Decimal(liste_paiement[i]) > 0) :
								commande = Commande.objects.get(id = liste_facture[i])
								if t > 1 :
									#paiement.facture.add(facture)
									detailsgourppaiement = Detailsgrouppaiement(grouppaiement = paiement, commande = commande , montant = liste_paiement[i] )
									detailsgourppaiement.save()

								elif t == 1 : 
									Paiement.objects.filter(id = last_paiement).update(commande = commande)
								commande_reste = commande.reste - decimal.Decimal(liste_paiement[i])		
								Commande.objects.filter(id = liste_facture[i]).update(reste = commande_reste)
								if commande_reste > 0 :
									Commande.objects.filter(id = liste_facture[i]).update(paiement ='partiellement payee')		
								elif  commande_reste == 0 :	
									Commande.objects.filter(id = liste_facture[i]).update(paiement ='paye')
								else :			
									Commande.objects.filter(id = liste_facture[i]).update(paiement ='partiellement payee')		
							
					messages.success(request, 'paiement a été bien ajouter')
				else :
						messages.success(request, 'qsdqsdfsf')
				
	return redirect('liste_paiement_effectues')


@login_required(login_url="/login/")
def afficher_modifier_paiement(request):
    context = {}
    if request.method == "POST":
    	id_paiement = request.POST.get('paiement')
    	type_paiement = request.POST.get('type')
    	context['type'] = type_paiement
    	if type_paiement == "paiement" :
    		paiement = Paiement.objects.get(id = id_paiement)
    		context['paiement'] = paiement
    		context['montant_max'] = paiement.commande.reste + paiement.montant
    		return render(request, 'modifier-paiment.html', context)	

    	else :
    		paiement = GroupPaiement.objects.get(id = id_paiement)
    		detailsgroupspaiement =Detailsgrouppaiement.objects.filter(grouppaiement = paiement)
    		montant_max = 0 
    		for j in range(len(detailsgroupspaiement)):
	    		montant_max = detailsgroupspaiement[j].commande.reste + detailsgroupspaiement[j].montant + montant_max

    		context['paiement'] = paiement
    		context['montant_max'] = montant_max
    		context['detailsgroupspaiement'] = detailsgroupspaiement
    		# messages.success(request, 'paiment est groupe')
    		return render(request, 'modifier-paiement-nouveau.html', context)		
    
    return render(request, 'paiement-effectues.html', context)	


@login_required(login_url="/login/")
def valider_modifier_paiement(request):
    context = {}
    if request.method == "POST":
    	id_paiement = request.POST.get('paiement')
    	date = request.POST.get('date')
    	montant = request.POST.get('montant')

    	paiement = Paiement.objects.get(id = id_paiement)
    	montant_prec = paiement.montant

    	commande = Commande.objects.get(id = paiement.commande.id)
    	client_or_fournisseur = ''
    	
    	if commande.type_commande =='bon_commande' :
    		client_or_fournisseur = 'fournisseur'
    	else :
    		client_or_fournisseur = 'client'
    	if date :
    		Paiement.objects.filter(id = id_paiement).update(date = date)

    	Paiement.objects.filter(id = id_paiement).update(montant = montant)
    	if decimal.Decimal( montant) > montant_prec :
    		dif = decimal.Decimal( montant) - montant_prec
    		Commande.objects.filter(id = paiement.commande.id).update(reste = commande.reste - dif )
    	else :
    		dif = montant_prec - decimal.Decimal( montant)  
    		Commande.objects.filter(id = paiement.commande.id).update(reste = commande.reste +  dif )


    	if commande.reste - decimal.Decimal(montant )== 0 :
    		Commande.objects.filter(id = paiement.commande.id).update(paiement = "paye")
    	elif commande.reste - decimal.Decimal(montant) == commande.total :
    		Commande.objects.filter(id = paiement.commande.id).update(paiement = "impaye")
    	else :
    		Commande.objects.filter(id = paiement.commande.id).update(paiement = "partiellement payee")
    
    	messages.success(request, 'paiement a été bien modifier')	
    if client_or_fournisseur == 'client' :
    	return redirect('liste_paiement_recu')
    else :	
    	return redirect('liste_paiement_effectues')

@login_required(login_url="/login/")
def supprimer_paiement(request):

	if request.method == "POST":
		id_paiement = request.POST.get('paiement')
		type_paiement = request.POST.get('type')
		client_or_fournisseur = ''
		if type_paiement == "paiement" :
				paiement = Paiement.objects.get(id = id_paiement)
				commande = Commande.objects.get(id = paiement.commande.id)	
				reste_commande = commande.reste + paiement.montant
				Commande.objects.filter(id = paiement.commande.id).update(reste = reste_commande)
					
				if commande.type_commande == 'bon_commande' :
					client_or_fournisseur = 'fournisseur'
				else :
					client_or_fournisseur = 'client'

				if  reste_commande == commande.total :
					Commande.objects.filter(id = paiement.commande.id).update(paiement = "impaye")
				elif reste_commande == 0 :
					Commande.objects.filter(id = paiement.commande.id).update(paiement = "paye")
				else :
					Commande.objects.filter(id = paiement.commande.id).update(paiement = "Partiellement payee")
				paiement.delete()
		else :
			paiement = GroupPaiement.objects.get(id = id_paiement)
			detailsgrouppaiement = Detailsgrouppaiement.objects.filter(grouppaiement =  paiement)
			for i in range(len(detailsgrouppaiement)) :
				commande = Commande.objects.get(id = detailsgrouppaiement[i].commande.id)
				if commande.type_commande == 'bon_commande' :
					client_or_fournisseur = 'fournisseur'
				else :
					client_or_fournisseur = 'client'
				print('client_or_fournisseur ' ,client_or_fournisseur)

				reste_commande = commande.reste + detailsgrouppaiement[i].montant
				Commande.objects.filter(id = commande.id).update(reste = reste_commande)
				print('reste_commande ' ,reste_commande)
				if reste_commande == Commande.objects.get(id = commande.id).total :
					Commande.objects.filter(id = commande.id).update(paiement = 'impaye')
				elif reste_commande == 0 :
					Commande.objects.filter(id = commande.id).update(paiement = 'paye')
				else: 
					Commande.objects.filter(id = commande.id).update(paiement = 'partiellement payee')
						
			paiement.delete()

			messages.success(request, 'paiment groupe bien supprimer')
	if client_or_fournisseur == 'client' :
		return redirect('liste_paiement_recu')
	else :	
		return redirect('liste_paiement_effectues')




@login_required(login_url="/login/")
def valider_modifier_paiement_nouveau(request):
    context = {}
    if request.method == "POST":
    	id_paiement = request.POST.get('paiement')
    	date = request.POST.get('date')
    	montant = request.POST.get('montant')

    	liste_details = request.POST.getlist('details_options[]')
    	liste_paiement = request.POST.getlist('paiement_enrg[]')

    	paiement = GroupPaiement.objects.get(id = id_paiement)
    	if date :
    		GroupPaiement.objects.filter(id = id_paiement).update(date = date)
    	GroupPaiement.objects.filter(id = id_paiement).update(montant = montant)
    	detailsgrouppaiement = Detailsgrouppaiement.objects.filter(grouppaiement =  paiement)

    	client_or_fournisseur = ''
    	for i in range(len(liste_details)) :
    		detailsgrouppaiement = Detailsgrouppaiement.objects.get(id = liste_details[i])
    		montant_prec = detailsgrouppaiement.montant
    		commande = Commande.objects.get(id = detailsgrouppaiement.commande.id)

    		if decimal.Decimal(liste_paiement[i]) > montant_prec :
    			diff = decimal.Decimal(liste_paiement[i]) - montant_prec
    			commande_reste = commande.reste - diff
    		else :
    			diff = montant_prec - decimal.Decimal(liste_paiement[i])
    			commande_reste = commande.reste + diff

    		if decimal.Decimal(liste_paiement[i]) == 0 :
    			detailsgrouppaiement.delete()
    		else :
    			Detailsgrouppaiement.objects.filter(id = liste_details[i]).update(montant = liste_paiement[i])
	    	

	    	Commande.objects.filter(id = detailsgrouppaiement.commande.id).update(reste = commande_reste)
	    	if commande.type_commande == 'bon_commande' :
	    		client_or_fournisseur ='fournisseur'
	    	else :	
	    		client_or_fournisseur = 'client'
	    	if  commande_reste == commande.total :
	    		Commande.objects.filter(id = detailsgrouppaiement.commande.id).update(paiement = 'impaye')
	    	elif commande_reste == 0 :
	    		Commande.objects.filter(id = detailsgrouppaiement.commande.id).update(paiement = 'paye')
	    	else :
	    		Commande.objects.filter(id = detailsgrouppaiement.commande.id).update(paiement = 'partiellement payee')

    	messages.success(request, 'paiment à ete bien modifier')
    if client_or_fournisseur == 'client' :
    	return redirect('liste_paiement_recu')
    else :	
    	return redirect('liste_paiement_effectues')


class ViewPDFPaiement(View):
	def get(self, request, *args, **kwargs):
		id_paiement = request.GET.get('paiement')
		type_paiement = request.GET.get('type')
		print('id ',id_paiement)
		if type_paiement == 'paiement' :
			data = {
				"paiement": Paiement.objects.get(id = id_paiement),
				"type":type_paiement
			}
		else :
			data = {
				"paiement": GroupPaiement.objects.get(id = id_paiement),
				"Detailsgrouppaiement": Detailsgrouppaiement.objects.filter(grouppaiement_id = id_paiement),
				"type":type_paiement
			}
		pdf = render_to_pdf('paiement.html', data)
		return HttpResponse(pdf, content_type='application/pdf')

class DownloadPDFPaiement(View):
	def get(self, request,*args,**kwargs):
		id_paiement = request.GET.get('paiement') 
		type_paiement = request.GET.get('type')

		print('id ',id_paiement)
		if type_paiement == 'paiement' :
			data = {
				"paiement": Paiement.objects.get(id = id_paiement),
				"type":type_paiement
			}
		else :
			data = {
				"paiement": GroupPaiement.objects.get(id = id_paiement),
				"Detailsgrouppaiement": Detailsgrouppaiement.objects.filter(grouppaiement_id = id_paiement),
				"type":type_paiement
			}

		pdf = render_to_pdf('paiement.html',data)
		#filename = "Invoice_%s.pdf" %("12341231")
		content = "attachment; filename= paiement.pdf"
		response = HttpResponse(pdf,content_type = 'application/pdf')
		response['Content-Disposition'] = content
		return response
