from django.db import models
from commandes.models import Commande
from decimal import Decimal
from django.core.validators import MinValueValidator
from django.contrib.auth.models import User
# Create your models here.
class Retour(models.Model):
	numero_retour = models.CharField(max_length=32, null=True, blank=True, unique = True)
	date_retour = models.DateField(null=True, blank=True)
	motif = models.CharField(max_length = 100,blank=True , null=True)
	commande = models.ForeignKey(Commande, on_delete=models.SET_NULL, null=True, blank=True)
	statut = models.CharField(max_length = 59,blank=True , null=True, default='approuve')
	staut_reception = models.CharField(max_length = 59,blank=True , null=True, default='')
	staut_remboursement = models.CharField(max_length = 59,blank=True , null=True, default='')
	user = models.CharField(max_length=50, null=True, blank=True)
	quantitee_renvoyee = models.DecimalField(decimal_places=0, max_digits=19, blank=True, default=0, validators=[MinValueValidator(Decimal('0.00'))])
	quantitee_recu = models.DecimalField(decimal_places=0, max_digits=19, blank=True, default=0, validators=[MinValueValidator(Decimal('0.00'))])
	montant_remboursee = models.DecimalField(decimal_places=2, max_digits=19, blank=True, default=0, validators=[MinValueValidator(Decimal('0.00'))])
	created_at = models.DateTimeField(auto_now_add=True)
	total = models.DecimalField(decimal_places=2, max_digits=19, blank=True, default=0, validators=[MinValueValidator(Decimal('0.00'))])
	userop = models.ForeignKey(User, on_delete=models.SET_NULL , null=True, blank=True )





